/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.base.ui.editpart.request;

import org.eclipse.gef.requests.CreateRequest;
import org.fortiss.tooling.kernel.ui.dnd.ElementCompositionSource;

/**
 * A GEF {@link CreateRequest} that creates a new element composition.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating GREEN Hash: 1DAE7E8D26B307774D480861A73F011C
 */
public final class CreateElementCompositionRequest extends CreateRequest {

	/** The request id constant. */
	public static final String REQ_ELEMENT_COMPOSITION = "create element composition via service";

	/** Stores the drag source object. */
	private ElementCompositionSource source;

	/** Constructor. */
	public CreateElementCompositionRequest() {
		super(REQ_ELEMENT_COMPOSITION);
	}

	/** {@inheritDoc} */
	@Override
	public Object getNewObject() {
		return source.getDesignatedElement();
	}

	/** Returns the drag source object. */
	public ElementCompositionSource getDragSource() {
		return source;
	}

	/** Sets the drag source object. */
	public void setDragSource(ElementCompositionSource source) {
		this.source = source;
	}
}
