/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2016 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.ui.internal.introspection.items;

import java.util.List;
import java.util.Map;

import org.fortiss.tooling.kernel.introspection.IIntrospectionDetailsItem;
import org.fortiss.tooling.kernel.introspection.items.EObjectAwareIntrospectionDetailsItemBase;
import org.fortiss.tooling.kernel.model.constraints.IConstraint;
import org.fortiss.tooling.kernel.ui.extension.IConstraintVerifierUI;
import org.fortiss.tooling.kernel.ui.service.IConstraintVerificationUIService;

/**
 * {@link IIntrospectionDetailsItem} for {@link IConstraintVerificationUIService}.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: 2C1421E2DD2D991E6BCA5F0936309CF6
 */
public final class ConstraintVerificationUIServiceIntrospectionDetailsItem extends
		EObjectAwareIntrospectionDetailsItemBase<IConstraintVerifierUI<IConstraint>> {

	/** Constructor. */
	public ConstraintVerificationUIServiceIntrospectionDetailsItem(
			Map<Class<?>, List<IConstraintVerifierUI<IConstraint>>> handlerMap) {
		super(handlerMap);
	}
}
