/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2016 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.extension;

import org.fortiss.tooling.kernel.extension.data.Prototype;

/**
 * Instances of this interface provide white lists for non-UI tool functions
 * globally enabled in tutorial or locally enabled in a tutorial step.
 * 
 * @author hoelzl
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating YELLOW Hash: 04AFC7CF6BA661282BEE153C4617D4B7
 */
public interface ITutorialWhitelistProvider {
	/**
	 * Returns whether the given prototype is active in this tutorial. Note that active
	 * prototypes may still be filtered by other methods of whitelist providers, in particular those
	 * related to the UI services.
	 */
	boolean prototypeActive(Prototype prototype);
}
