/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2016 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.extension.base;

import org.fortiss.tooling.kernel.extension.IConstraintVerifier;
import org.fortiss.tooling.kernel.model.constraints.IConstraint;

/**
 * Base for {@link IConstraintVerifier}.
 * 
 * @author aravantinos
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: E5CFC673BC6F702E41A7E94D053FFA7F
 */
public abstract class ConstraintVerifierBase<T extends IConstraint> implements
		IConstraintVerifier<T> {

	/** Gets a general description for the constraint type. */
	@Override
	public String getDescription() {
		return "";
	}

	/** True if this constraint shall be displayed as a development process constraint. */
	@Override
	public boolean isUsableForDevelopmentProcess() {
		return true;
	}

	/** {@inheritDoc} */
	@Override
	public String getID() {
		return this.getClass().getName();
	}
}
