/*-------------------------------------------------------------------------+
|                                                                          |
| Copyright 2005-2011 The ConQAT Project                                   |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+-------------------------------------------------------------------------*/
package org.conqat.ide.commons.ui.jface;

import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.swt.SWT;

/**
 * This interface describes columns as they are used in JFace viewers.
 * 
 * @author deissenb
 * @author $Author: deissenb $
 * @version $Rev: 34252 $
 * @levd.rating GREEN Hash: E800F9D227B578D38A3D0BA853DF27B2
 */
public interface IColumn {

	/** Get column title. */
	public String getTitle();

	/** Get column label provider for this column. */
	public ColumnLabelProvider getLabelProvider();

	/** Get column width. */
	public int getWidth();

	/**
	 * Get alignment, one of {@link SWT#LEFT}, {@link SWT#CENTER},
	 * {@link SWT#RIGHT}
	 */
	public int getAlignment();
}